tags: master, kube-apiserver, kube-scheduler, kube-controller-manager

# 06-1.部署 master 节点

<!-- TOC -->

- [06-1.部署 master 节点](#06-1部署-master-节点)
    - [安装和配置 kube-nginx](#安装和配置-kube-nginx)
    - [下载最新版本二进制文件](#下载最新版本二进制文件)

<!-- /TOC -->

kubernetes master 节点运行如下组件：

+ kube-apiserver
+ kube-scheduler
+ kube-controller-manager
+ kube-nginx

kube-scheduler 和 kube-controller-manager 可以以集群模式运行，通过 leader 选举产生一个工作进程，其它进程处于阻塞模式。

这两个组件需要高可用模式访问 kube-apiserver，所以也需要部署 kube-nginx 组件。

注意：如果没有特殊指明，本文档的所有操作**均在 m7-autocv-gpu01 节点上执行**，然后远程分发文件和执行命令。

## 安装和配置 kube-nginx

参考 [06-0.apiserver高可用之nginx代理.md](06-0.apiserver高可用之nginx代理.md)

## 下载最新版本二进制文件

从 [CHANGELOG 页面](https://github.com/kubernetes/kubernetes/blob/master/CHANGELOG.md) 下载 server tarball 文件。

``` bash
cd /opt/k8s/work
wget https://dl.k8s.io/v1.12.3/kubernetes-server-linux-amd64.tar.gz
tar -xzvf kubernetes-server-linux-amd64.tar.gz
cd kubernetes
tar -xzvf  kubernetes-src.tar.gz
```

将二进制文件拷贝到所有 master 节点：

``` bash
cd /opt/k8s/work/kubernetes
source /opt/k8s/bin/environment.sh
for node_ip in ${NODE_IPS[@]}
  do
    echo ">>> ${node_ip}"
    scp server/bin/* root@${node_ip}:/opt/k8s/bin/
    ssh root@${node_ip} "chmod +x /opt/k8s/bin/*"
  done
```