tags: worker, flanneld, docker, kubeconfig, kubelet, kube-proxy

# 07-0.部署 worker 节点

<!-- TOC -->

- [07-0.部署 worker 节点](#07-0部署-worker-节点)
    - [安装和配置 flanneld](#安装和配置-flanneld)
    - [安装和配置 kube-nginx](#安装和配置-kube-nginx)
    - [安装依赖包](#安装依赖包)

<!-- /TOC -->

kubernetes work 节点运行如下组件：

+ docker
+ kubelet
+ kube-proxy
+ flanneld
+ kube-nginx

注意：如果没有特殊指明，本文档的所有操作**均在 m7-autocv-gpu01 节点上执行**，然后远程分发文件和执行命令。

## 安装和配置 flanneld

参考 [05-部署flannel网络.md](./05-部署flannel网络.md)

## 安装和配置 kube-nginx

参考 [06-0.apiserver高可用之nginx代理.md](06-0.apiserver高可用之nginx代理.md)

## 安装依赖包

CentOS:

``` bash
source /opt/k8s/bin/environment.sh
for node_ip in ${NODE_IPS[@]}
  do
    echo ">>> ${node_ip}"
    ssh root@${node_ip} "yum install -y epel-release"
    ssh root@${node_ip} "yum install -y conntrack ipvsadm ipset jq iptables curl sysstat libseccomp && /usr/sbin/modprobe ip_vs "
  done
```

Ubuntu: 

``` bash
source /opt/k8s/bin/environment.sh
for node_ip in ${NODE_IPS[@]}
  do
    echo ">>> ${node_ip}"
    ssh root@${node_ip} "apt-get install -y conntrack ipvsadm ipset jq iptables curl sysstat libseccomp && /usr/sbin/modprobe ip_vs "
  done
```